Subject: RE: Regarding LDP scalability

From: Shahram Davari <[email-masked]>
Date: Mon, 2 Dec 2002 11:07:52 -0800

Here is how you do it:
 
Network1 - R1 <-> LER1 <-> LSR1 <-> LSR2 <-> LER2 <-> R2 - Network2

<---IP Network---><------------MPLS Network---------><---IP Network--->
 
LER1 runs DoD LDP and requests a label for Prefix=LER2 address (LSP12)
LER2 does the same and requests a label for Prefix=LER1 address (LSP21)
LSP12 could be viewed as a single link connecting LER1 and LER2,
and therefore could be advertised (as FA) in IGP. Same thing for LSP21.
Let's say Prefix X is in Network2. LER2 advertises X to all its neigbors
including LSR2 and LER1 (which looks like a neighbor, due to LSP21). 
When LER1 is computing the SPF, the shortest path to Network2 is obviously
LER2 via LSP12.
 
-Shahram

-----Original Message-----
From: Carlos M. Pignataro [mailto:[email-masked]]
Sent: Monday, December 02, 2002 10:52 AM
To: Shahram Davari; Intae Jung; [email-masked]; [email-masked]
Subject: RE: Regarding LDP scalability

Shahram,

At 07:20 AM 12/2/2002 -0800, Shahram Davari wrote:

Carlos,
 
1. Run MPLS TE Tunnels between the edge routers and have the edge routers learn these routes through the Tunnel (but you mention only LDP distributing labels).
 
Why do we need to run TE. Can't you establish full mesh LSPs between edge routers, by running LDP DoD, only for edge router addresses. 

Normally, in a non-vc-merge environment, an LER will request labels (LDP DoD) for all entries in its routing table. Even if the next hop is the same, different LSPs will be signalled. That's why option 2 summarize the IGP.

Then all prefixes could be advertised also inside these LSPs and
be used by ingress LERs.

How would we do that. An LDP signaled LSP is for a particular FEC. (FEC-Label mapping). New prefix -> new LSP. Check RCF 3031 section 5.1.1.4. PulledConditional and RFC 3035 section 8.1. Edge LSR Behavior.
If LDP signals LSPs for only the edge router addresses, all other prefixes will not use that LSP.

Regards,

Carlos.

Yours,
-Shahram 

-----Original Message-----
From: Carlos M. Pignataro [ mailto:[email-masked] <mailto:[email-masked]> ]
Sent: Monday, December 02, 2002 9:52 AM
To: Intae Jung; [email-masked]; [email-masked]
Subject: Re: Regarding LDP scalability

Intae,

At 12:09 AM 11/30/2002 +0900, Intae Jung wrote:

Hello,
I'd like to ask a couple of questions regarding a scalability of LDP, 
especially when it is deployed in an ATM-LSR, adopting Downstream on
Demand distribution with conservative label retension and ordered control,
where labels (VPI/VCI) are a relatively scarce resource that must be conserved
in ATM switch. The VPI/VCI is a particularly valuable and limited resource that 
should be saved when an ATM LSR is not able to support VC-merging capability.
Unfortunately the system I'm managing has no VC-merging capability.
As defined in the standard, LDP attempts to setup or release a hop-by-hop LSP 
whenever a new route is added or deleted in an ATM LER through routing protocols, 
mainly IGP such as OSPF, ISIS or RIP.
Let me assume a sample ATM-MPLS network as follows.

Network1 - R1 <-> LER1 <-> LSR1 <-> LSR2 <-> LER2 <-> R2 - Network2

<---IP Network---><------------MPLS Network---------><---IP Network--->

R1, R2: Router operating IGP (OSPF or RIP)
LER1, LER2: Edge ATM LSR operating LDP and IGP (iBGP if needed)
LSR1, LSR2: ATM LSR operating LDP and IGP (OSPF or IS-IS)

OSPF or RIP is used in the IP Network and OSPF or IS-IS is deployed 
in the MPLS Network. An i-BGP session could be setup between LER1 and LER2
if needed, but not necessarily since LER1 and LER2 are not supposed to provide 
BGP/MPLS functionality, in other words, they don't work as a PE(Provider Edge) router. 
LER1, LER2, LSR1 and LSR2 support only LDP as an MPLS signaling protocol.

The problem is that the number of LSP's from LER1 to LER2 increases
as the number of networks increases in the Network2, meaning that the number of
routing entries in LER1 increases accordingly, wherease the number of LSPs supported
by LER1 is a lot smaller than the number of its route entries.
Eventually, as the number of LSPs setup exceeds the maximum number of LSP's,
we'll not be able to setup an LSP any more even though new routes are added.
As I mentioned above, LSR1 and LSR2 don't support VC-merging capability, 
thus the scalability becomes quite servere.
Therefore w're trying to figure out how to support a lot of routing entries using
a limited number of LSP's. We are trying to come up with a mechanism that setups 
just one LSP between LER1 and LER2, which could be shared between all best-effort
traffic between Network1 and Networks2.

Some options to reduce the # of LSPs would be: 
1. Run MPLS TE Tunnels between the edge routers and have the edge routers learn these routes through the Tunnel (but you mention only LDP distributing labels).
2. Summarize the networks on the edge routers (using your IGP).
3. As you mention, use iBGP.

Some implementations also improve scalability by allowing an edge router, by configuration, to selects FECs for which to request a label (using DoD), as well as disabling ATM LSRs from requesting labels.

Thanks,

Carlos.

The problem we faced is how to setup only 1 LSPs between LERs automatically, 
and then how to map a lot of route entries to the shared LSP.
Although two LER's are shown in the example, the number of LSP's between LER's
can be quite large as the number of LER's increases.
We're considering to setup a full-mesh iBGP sessions between all LER's, and
to use BGP next hop gateway in order to get an FEC-to-NHFLE mapping.
In other words, routes from Network2 will be redistributed to LER1 via iBGP session
between LER1 and LER2, and then LER1 will setup just one LSP for the BGP next hop
address and map all routes from Network1 to the LSP.
However it enforces us to setup iBGP sessions between all of LER's even though
we don't need them unless we deploy MPLS. We're also wondering whether
we'll be able to solve the problem using any IGP capability, like tag field of AS-external 
LSA in OSPF.

Please enlighten us on this issue. 
Any experience or idea will be greatly appreciated.
Thanks in advance.

Regards,

Jung.

=================================================================
                            |  Carlos Pignataro - CCIE 4619
     cisco Systems, Inc.    |  Escalation RTP
                            |  [email-masked]
       ||         ||        |  +1 919 392 7428 - office
      .||.       .||.       |  +1 919 345 3028 - mobile
     .||||.     .||||.      |  +1 919 392 6470 - fax
  .:||||||||:.:||||||||:.   |  7025 Kit Creek Road, PO Box 14987
      Are you Ready ?       |  Research Triangle Park, NC 27709
================================================================= 

=================================================================
                            |  Carlos Pignataro - CCIE 4619
     cisco Systems, Inc.    |  Escalation RTP
                            |  [email-masked]
       ||         ||        |  +1 919 392 7428 - office
      .||.       .||.       |  +1 919 345 3028 - mobile
     .||||.     .||||.      |  +1 919 392 6470 - fax
  .:||||||||:.:||||||||:.   |  7025 Kit Creek Road, PO Box 14987
      Are you Ready ?       |  Research Triangle Park, NC 27709
=================================================================

---

From: "Yongjun Im" <[email-masked]>
Date: Tue, 3 Dec 2002 13:41:03 +0900

I agree it's one of best approaches, described by Shahram below, to reduce 
the number of LSP's signalled by LDP. AFAIK, one vednor already support it.
However, in order to support that kind of scheme, it is required that whenever 
an LSP is established between two LER's, additional IP subinterface between 
an LER and its neighboring LSR, operating IGP, should be installed with respect to 
that LSP. Normaly, single IP interface is maintained between an ingress ATM LER 
and its adjacent LSR, through MPLS control channel (VPI/VCI=0/32). However, 
in order to support the mechanism described below, we have to provide additional 
functionality supporting a routing protocol for LSP subinterface, which can be 
established or released dynamically. I also believe this mechanim could boil down
to full-mesh IPoA network configuration, requiring PVC's and routing adjacencies 
between routers through ATM network.
I'm wondering whether there is any mechanism not requring any change to IP interface 
or routing protocol management.

Yongjun.

  ----- Original Message ----- 
  From: Shahram Davari 
  To: 'Carlos M. Pignataro' ; Intae Jung ; [email-masked] ; [email-masked] 
  Sent: Tuesday, December 03, 2002 4:07 AM
  Subject: RE: Regarding LDP scalability

  Here is how you do it:

  -Shahram
    -----Original Message-----
    From: Carlos M. Pignataro [mailto:[email-masked]]
    Sent: Monday, December 02, 2002 10:52 AM
    To: Shahram Davari; Intae Jung; [email-masked]; [email-masked]
    Subject: RE: Regarding LDP scalability

    Shahram,

      Carlos,

    Regards,

    Carlos.

      Yours,
      -Shahram 

        -----Original Message-----
        From: Carlos M. Pignataro [mailto:[email-masked]]
        Sent: Monday, December 02, 2002 9:52 AM
        To: Intae Jung; [email-masked]; [email-masked]
        Subject: Re: Regarding LDP scalability

        Intae,

          Hello,

        Thanks,

        Carlos.

          Regards,

          Jung.

---

From: "James R. Leu" <[email-masked]>
Date: Tue, 3 Dec 2002 11:03:19 -0600

In January of 2001 I published a draft which addressed this problem.
It has since expired.

http://www.alternic.org/drafts/drafts-l-m/draft-leu-mpls-ldp-label-aggregation-00.html

-- 
James R. Leu

---

From: Eric Rosen <[email-masked]>
Date: Tue, 03 Dec 2002 10:38:28 -0500

Generally the number  of VCs which an ATM switch can  support is larger than
the number  of IGP routes, and  it's only the  IGP routes that need  to have
labels assigned to them.  Are you leaking BGP routes into your IGP?

---

From: "Yongjun Im" <[email-masked]>
Date: Wed, 4 Dec 2002 08:51:59 +0900

It could be true, but the number of VCs per PORT/LINK
which an ATM switch can support could be a lot smaller than
the number of IGP routes, which could share the same next hop
link to an LSR. In addition, it simply cannot be assumed that IGP routes
only need to have labels assigned to them, since eBGP routes from
an LER can be redistributed into an iBGP peer that is another LER.
As you stated, it is well known that BGP routes are seldom redisributed
into IGP.

Yongjun.

----- Original Message -----
From: "Eric Rosen" <[email-masked]>
To: "Yongjun Im" <[email-masked]>
Cc: "Shahram Davari" <[email-masked]>; "'Carlos M. Pignataro'" <[email-masked]>;
<[email-masked]>; <[email-masked]>; "ÀåÀç¿µ" <[email-masked]>; "¹èÃ¶¹Î" <[email-masked]>
Sent: Wednesday, December 04, 2002 12:38 AM
Subject: Re: Regarding LDP scalability